import 'dart:html';

/// Set of recognized key codes from browser KeyboardEvents
///
/// See [KeyboardEvent.code]
class KeyCode {
  // function keys
  static const f1 = 'F1';
  static const f2 = 'F2';
  static const f3 = 'F3';
  static const f4 = 'F4';
  static const f5 = 'F5';
  static const f6 = 'F6';
  static const f7 = 'F7';
  static const f8 = 'F8';
  static const f9 = 'F9';
  static const f10 = 'F10';
  static const f11 = 'F11';
  static const f12 = 'F12';

  // digits
  static const digit1 = 'Digit1';
  static const digit2 = 'Digit2';
  static const digit3 = 'Digit3';
  static const digit4 = 'Digit4';
  static const digit5 = 'Digit5';
  static const digit6 = 'Digit6';
  static const digit7 = 'Digit7';
  static const digit8 = 'Digit8';
  static const digit9 = 'Digit9';
  static const digit0 = 'Digit0';

  // commands
  static const escape = 'Escape';
  static const backspace = 'Backspace';
  static const enter = 'Enter';
  static const tab = 'Tab';
  static const home = 'Home';
  static const end = 'End';

  // symbols
  static const backquote = 'Backquote';
  static const minus = 'Minus';
  static const equal = 'Equal';
  static const bracketLeft = 'BracketLeft';
  static const bracketRight = 'BracketRight';
  static const backslash = 'Backslash';
  static const semicolon = 'Semicolon';
  static const quote = 'Quote';
  static const comma = 'Comma';
  static const period = 'Period';
  static const slash = 'Slash';

  // arrows
  static const arrowUp = 'ArrowUp';
  static const arrowDown = 'ArrowDown';
  static const arrowLeft = 'ArrowLeft';
  static const arrowRight = 'ArrowRight';

  // modifiers
  static const capsLock = 'CapsLock';
  static const shiftLeft = 'ShiftLeft';
  static const shiftRight = 'ShiftRight';
  static const ctrlLeft = 'ControlLeft';
  static const ctrlRight = 'ControlRight';
  static const altLeft = 'AltLeft';
  static const altRight = 'AltRight';
  static const metaLeft = 'MetaLeft';
  static const metaRight = 'MetaRight';
  static const osLeft = 'OSLeft';
  static const osRight = 'OSRight';

  // characters
  static const space = 'Space';
  static const keyA = 'KeyA';
  static const keyB = 'KeyB';
  static const keyC = 'KeyC';
  static const keyD = 'KeyD';
  static const keyE = 'KeyE';
  static const keyF = 'KeyF';
  static const keyG = 'KeyG';
  static const keyH = 'KeyH';
  static const keyI = 'KeyI';
  static const keyJ = 'KeyJ';
  static const keyK = 'KeyK';
  static const keyL = 'KeyL';
  static const keyM = 'KeyM';
  static const keyN = 'KeyN';
  static const keyO = 'KeyO';
  static const keyP = 'KeyP';
  static const keyQ = 'KeyQ';
  static const keyR = 'KeyR';
  static const keyS = 'KeyS';
  static const keyT = 'KeyT';
  static const keyU = 'KeyU';
  static const keyV = 'KeyV';
  static const keyW = 'KeyW';
  static const keyX = 'KeyX';
  static const keyY = 'KeyY';
  static const keyZ = 'KeyZ';

  // numpad
  static const numpad0 = 'Numpad0';
  static const numpad1 = 'Numpad1';
  static const numpad2 = 'Numpad2';
  static const numpad3 = 'Numpad3';
  static const numpad4 = 'Numpad4';
  static const numpad5 = 'Numpad5';
  static const numpad6 = 'Numpad6';
  static const numpad7 = 'Numpad7';
  static const numpad8 = 'Numpad8';
  static const numpad9 = 'Numpad9';
  static const numpadDecimal = 'NumpadDecimal';
  static const numpadAdd = 'NumpadAdd';
  static const numpadSubtract = 'NumpadSubtract';
  static const numpadMultiply = 'NumpadMultiply';
  static const numpadDivide = 'NumpadDivide';
  static const numpadEqual = 'NumpadEqual';
  static const numpadEnter = 'NumpadEnter';
}
